import interfascia.*;
import de.bezier.data.sql.*;
import bluetoothDesktop.*;

//bt defs
PFont font;
Bluetooth bt;
String statusMsg = "inactive";
Service[] services = new Service[0];
Device[] devices = new Device[0];
Client[] clients = new Client[0];
final String SERVICE_NAME = "SPP"; //set upthe service type for bluetooth
Client server;
boolean Is_Con = false; //is connected.
boolean Is_Contin = false; //is continuous mode

//gui deffs
GUIController c;
IFButton b1, b2, b3, start_c, stop_c, contin_c, sleep_c, clear_c, dump_c;
IFLabel status_label, status_val;
IFTextField interval_c;

//mysql init
MySQL msql;

//create a global var to track the button 
//state since no data members exist for this.
//these are set outside of setup to make them global vars.
boolean b1_active = false; 
boolean b2_active = false; 
boolean b3_active = false; 
int datval = 0;
long dataset_key = 1000000000; // this is the default value. This value is essentually
//a unix timestamp that is used for the rest

void setup() {
  size(300, 200);
  background(51);
  //setup the interface


  c = new GUIController (this);
// x, y, width, height
  b1 = new IFButton ("Connect", 5, 10, 55, 17);
  b2 = new IFButton ("Test Query", 65, 10, 70, 17);
  b3 = new IFButton ("Connect to Bluetooth", 5, 32, 130, 17);

//use 54 as y
  start_c = new IFButton ("start", 5, 76, 55, 17);
  stop_c = new IFButton ("stop", 65, 76, 55, 17);
  contin_c = new IFButton ("continuous", 5, 98, 80, 17);
  sleep_c = new IFButton ("sleep", 125, 76, 55, 17);
  clear_c = new IFButton ("clear memory", 185, 76, 85, 17);
  dump_c = new IFButton ("dump memory", 185, 98, 85, 17);
//  sleep_c = new IFButton ("sleep", 5, 120, 55, 17);

  interval_c = new IFTextField("Interval", 90,96,35, "10");
  status_label = new IFLabel("Current status: ", 5, 58);
  status_val = new IFLabel("Disconnected", 90, 58);
  

  b1.addActionListener(this);
  b2.addActionListener(this);
  b3.addActionListener(this);
  
  start_c.addActionListener(this);
  stop_c.addActionListener(this);
  contin_c.addActionListener(this);
  sleep_c.addActionListener(this);
  clear_c.addActionListener(this);
  dump_c.addActionListener(this);
  
  interval_c.addActionListener(this);
  

  
  c.add (b1);
  c.add (b2);
  c.add (b3);

  c.add (start_c);
  c.add (stop_c);
  c.add (contin_c);
  c.add (sleep_c);
  c.add (clear_c);
  c.add (dump_c);
  
  c.add (interval_c);
  
  c.add (status_label);
  c.add (status_val);
  
  //DB Setup
  //
  String user     = "root";
  String pass     = "garden";
  // name of the database to use
  String database = "uproc_data";
  // add additional parameters like this:
  // bildwelt?useUnicode=true&characterEncoding=UTF-8
  String server = "127.0.0.1:5555"; //add the host ip and port as such host:port	
  // define connection to database server
  msql = new MySQL( this, server, database, user, pass );
}

void draw() {
  if (Is_Con){
       if(Is_Contin){
        int nrBytes = server.available();
        if (nrBytes >1) {
          //byte[] inBytes = new byte[nrBytes];
          //server.readBytes(inBytes); //orginally readBytes
          //server.write(4);      
          byte[] mybuff = new byte[nrBytes];
          //server.readBytes(mybuff,0,4);
          server.readBytes(mybuff);
          //int b = server.read();
          //msql.execute("insert into data_test values(null,'A'," + b +") " );
          //      print("The value is: ");
          //println(int(b));
      println("-----");
      for (int i = 0;i < nrBytes; i++)
      {println(mybuff[i]);}
/*        if (mybuff[0] == 65){
//         println(char(mybuff[0]));
         int a = char(mybuff[0]);
         int a_val = int(mybuff[1]);
//         println(int(mybuff[1]));
         int b = char(mybuff[2]);
         int b_val = mybuff[3];
//         println(char(mybuff[2]));         
//         println(mybuff[3]);
        msql.execute("insert into data_test values(null,'A', "+ a_val +") " );
        msql.execute("insert into data_test values(null,'B'," + b_val +") " );
        }
        */
        char channel = char(mybuff[0]);
        switch (channel) {
          // don't forget the single quotes for letters
          case 'A':
          int a_val = int(mybuff[1]);
          msql.execute("insert into data_test values(null,'A', "+ a_val +",now(),"+dataset_key+") " );
          break;
          case 'B':
          int b_val = mybuff[1];
          msql.execute("insert into data_test values(null,'B'," + b_val +",now(),"+dataset_key+") " );
          break;
/*          case C:
           println("this should not happen");
          break;          
*/          
          default:
          println("failure to match vars");
          println(channel);
          } 
        }
       else {
         if (server.available() < 0) {  //used to be >
            println("nothing to load");
            }
          }
    }
  }
  //end of draw
}

void actionPerformed (GUIEvent e) {
  if (e.getSource() == b1) {
    //background(100, 155, 100);
      if (b1.getLabel()== "Connect"){

        if ( msql.connect() )//maybe this should be a try/catch?
          {
          println("mysql connection established");
          b1.setLabel("close");  
          b1_active = true;
          if(b1_active == true)   {println("true");}
          }
        }
      else if(b1.getLabel()== "close"){
      msql.close();//closing the db connection.
      b1.setLabel("Connect");  
      println("mysql connection closed");
      b1_active = false;
        if(b1_active == false)  {println("false");}
      }  
      println ("Message: " + e.getMessage());
      // println ("Component: " + e.getSource().getLabel());
      } 
  else if (e.getSource() == b2) {
    //background(100, 100, 130);
    println ("Message: " + e.getMessage());
    msql.query( "SELECT unix_timestamp()" );
    msql.next();
    //dataset_key = msql.getLong( "unix_timestamp()" );
    //msql.execute("insert into data_test values(null,'A'," + datval++ +") " );
    String s = msql.getString("unix_timestamp()");
    println("unix_timestamp() " +s);
    }
 //B3
  if (e.getSource() == b3) {
    if (b3_active == true){
      server.stop();
      b3_active = false;
      println("bluetooth stopped");
      b3.setLabel("Connect to Bluetooth");        
    }
    else if(b3_active == false){
      try {
        bt = new Bluetooth(this, 0x0003); // RFCOMM
        // Start a Service
        bt.start("simpleService");
        bt.find();
        statusMsg = "starting search";
        println(statusMsg);
      } 
      catch (RuntimeException re) {
        statusMsg = "bluetooth off?";
        println(re);
        println(statusMsg);
        }
       }
     }
   //Start
   if (e.getSource() == start_c) {
       println("start command");
       server.write(1); 
       }
     
   if (e.getSource() == stop_c) {
       println("stop command");
       Is_Contin = false;
       server.write(2); 
       }
   if (e.getSource() == contin_c) {
       println("continuous mode");
       Is_Contin = true;
       //get the current timestamp and use that  as the dataset key value
       msql.query( "SELECT unix_timestamp()" );
       msql.next();
       dataset_key = msql.getLong( "unix_timestamp()" );
       println("dataset key: " +dataset_key);
       //println(int(interval_c.getValue()));
       server.write(3); 
       delay(750); //wait for almost a second
       server.write(int(interval_c.getValue())); 
       }
       
   if (e.getSource() == sleep_c) {
       println("sleep mode");
       server.write(4);        
       }
   if (e.getSource() == clear_c) {
       println("clear mode");
       server.write(5);        
       }   
   if (e.getSource() == dump_c) {
       println("dump mode");
       server.write(6);        
       }
} //end of action


void deviceDiscoverEvent(Device d) {
  statusMsg = "Found device at: " + d.address + "...";
  devices = (Device[])append(devices, d);
  println(statusMsg);
}

void deviceDiscoveryCompleteEvent(Device[] d) {
  statusMsg = "Found " + d.length + " devices found.";
  devices =  d;
  println(statusMsg);
}

void serviceDiscoverEvent(Service[] s) {
  statusMsg = "Found Service " + s[0].name + "...";
  services = (Service[])append(services,s[0]);
  println(statusMsg);
}

void serviceDiscoveryCompleteEvent(Service[] s) {
  Service[] services = (Service[])s;

  statusMsg = "Search completed.";
  println(statusMsg);
  // now search for the service we want
  for (int i=0; i<services.length; i++) {
    println(services[i].name);
    if (services[i].name.equals(SERVICE_NAME)) {//SERVICE_NAME = SPP
      statusMsg = "Service " + SERVICE_NAME + " found";

      try {
        // we found our service, so try to connect to it
        // if we try to connect to it more than once, this will throw an error.
        statusMsg = "Attempting connection on server " + devices[0].name;
        server = services[i].connect();
        statusMsg = "Connected to service " + SERVICE_NAME + " on server " + server.device.name;
        b3_active = true;
        Is_Con = true;
        b3.setLabel("Disconnect Bluetooth");  
        //server.write(4);
        println(statusMsg);
        return;
      } 
      catch (Exception e) {
        statusMsg = "Found service " + SERVICE_NAME + " on Server " + server.device.name + ", but connection failed";
        println(e);
        return;
      }
    } 
  }

  statusMsg = "Service " + SERVICE_NAME + " not found.";
  println(statusMsg);
}


